Module javafx.graphics
Package javafx.scene.shape

# Class Path

java.lang.Object
javafx.scene.Node
javafx.scene.shape.Shape
javafx.scene.shape.Path

All Implemented Interfaces:
  `Styleable`, `EventTarget`

public class Path extends Shape
The `Path` class represents a simple shape and provides facilities required for basic construction and management of a geometric path. Example:

    import javafx.scene.shape.*;

    Path path = new Path();

    MoveTo moveTo = new MoveTo();
    moveTo.setX(0.0f);
    moveTo.setY(0.0f);

    HLineTo hLineTo = new HLineTo();
    hLineTo.setX(70.0f);

    QuadCurveTo quadCurveTo = new QuadCurveTo();
    quadCurveTo.setX(120.0f);
    quadCurveTo.setY(60.0f);
    quadCurveTo.setControlX(100.0f);
    quadCurveTo.setControlY(0.0f);

    LineTo lineTo = new LineTo();
    lineTo.setX(175.0f);
    lineTo.setY(55.0f);

    ArcTo arcTo = new ArcTo();
    arcTo.setX(50.0f);
    arcTo.setY(50.0f);
    arcTo.setRadiusX(50.0f);
    arcTo.setRadiusY(50.0f);

    path.getElements().add(moveTo);
    path.getElements().add(hLineTo);
    path.getElements().add(quadCurveTo);
    path.getElements().add(lineTo);
    path.getElements().add(arcTo);

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final ObjectProperty<FillRule>`
  `fillRule`
  Defines the filling rule constant for determining the interior of the path.

  ### Properties declared in class javafx.scene.shape.Shape

  `fill, smooth, strokeDashOffset, strokeLineCap, strokeLineJoin, strokeMiterLimit, stroke, strokeType, strokeWidth`

  ### Properties declared in class javafx.scene.Node

  `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

- ## Field Summary

  ### Fields declared in class javafx.scene.Node

  `BASELINE_OFFSET_SAME_AS_HEIGHT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Path()`
  Creates an empty instance of Path.
  `Path(Collection<? extends PathElement> elements)`
  Creates new instance of Path
  `Path(PathElement... elements)`
  Creates a new instance of Path

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final ObjectProperty<FillRule>`
  `fillRuleProperty()`
  Defines the filling rule constant for determining the interior of the path.
  `final ObservableList<PathElement>`
  `getElements()`
  Gets observable list of path elements of this path.
  `final FillRule`
  `getFillRule()`
  Gets the value of the property fillRule.
  `final void`
  `setFillRule(FillRule value)`
  Sets the value of the property fillRule.
  `String`
  `toString()`
  Returns a string representation of this `Path` object.

  ### Methods declared in class javafx.scene.shape.Shape

  `fillProperty, getClassCssMetaData, getCssMetaData, getFill, getStroke, getStrokeDashArray, getStrokeDashOffset, getStrokeLineCap, getStrokeLineJoin, getStrokeMiterLimit, getStrokeType, getStrokeWidth, intersect, isSmooth, setFill, setSmooth, setStroke, setStrokeDashOffset, setStrokeLineCap, setStrokeLineJoin, setStrokeMiterLimit, setStrokeType, setStrokeWidth, smoothProperty, strokeDashOffsetProperty, strokeLineCapProperty, strokeLineJoinProperty, strokeMiterLimitProperty, strokeProperty, strokeTypeProperty, strokeWidthProperty, subtract, union`

  ### Methods declared in class javafx.scene.Node

  `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBaselineOffset, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, maxHeight, maxWidth, minHeight, minWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, prefHeight, prefWidth, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.css.Styleable

  `getStyleableNode`

- ## Property Details

  - ### fillRule

    public final ObjectProperty<FillRule> fillRuleProperty
    Defines the filling rule constant for determining the interior of the path. The value must be one of the following constants: `FillRile.EVEN_ODD` or `FillRule.NON_ZERO`. The default value is `FillRule.NON_ZERO`.
    Default value:
      FillRule.NON_ZERO
    See Also:
      - `getFillRule()`
      - `setFillRule(FillRule)`

- ## Constructor Details

  - ### Path

    public Path()
    Creates an empty instance of Path.

  - ### Path

    public Path(PathElement... elements)
    Creates a new instance of Path
    Parameters:
      `elements` - Elements of the Path
    Since:
      JavaFX 2.1

  - ### Path

    public Path(Collection<? extends PathElement> elements)
    Creates new instance of Path
    Parameters:
      `elements` - The collection of the elements of the Path
    Since:
      JavaFX 2.2

- ## Method Details

  - ### setFillRule

    public final void setFillRule(FillRule value)
    Sets the value of the property fillRule.
    Property description:
      Defines the filling rule constant for determining the interior of the path. The value must be one of the following constants: `FillRile.EVEN_ODD` or `FillRule.NON_ZERO`. The default value is `FillRule.NON_ZERO`.
    Default value:
      FillRule.NON_ZERO

  - ### getFillRule

    public final FillRule getFillRule()
    Gets the value of the property fillRule.
    Property description:
      Defines the filling rule constant for determining the interior of the path. The value must be one of the following constants: `FillRile.EVEN_ODD` or `FillRule.NON_ZERO`. The default value is `FillRule.NON_ZERO`.
    Default value:
      FillRule.NON_ZERO

  - ### fillRuleProperty

    public final ObjectProperty<FillRule> fillRuleProperty()
    Defines the filling rule constant for determining the interior of the path. The value must be one of the following constants: `FillRile.EVEN_ODD` or `FillRule.NON_ZERO`. The default value is `FillRule.NON_ZERO`.
    Default value:
      FillRule.NON_ZERO
    See Also:
      - `getFillRule()`
      - `setFillRule(FillRule)`

  - ### getElements

    public final ObservableList<PathElement> getElements()
    Gets observable list of path elements of this path.
    Returns:
      Elements of this path

  - ### toString

    public String toString()
    Returns a string representation of this `Path` object.
    Overrides:
      `toString` in class `Node`
    Returns:
      a string representation of this `Path` object.